%global _hardened_build 1

# Make reproducible builds possible
%global source_date_epoch_from_changelog 0
%global clamp_mtime_to_source_date_epoch 1
%global use_source_date_epoch_as_buildtime 1
%define _buildhost apkg

%{!?_syprefix: %define _syprefix /opt/symas }
%{!?_etcfix: %define _etcfix %{_syprefix}/etc }
%{!?_sylibdir: %define _sylibdir %{_syprefix}/lib }
%{!?_varfix: %define _varfix /var/symas }
%define debug_package %{nil}

%if 0%{?suse_version}
# We don't seem to have %{dist} in SUSEs, define our own
%{!?dist: %define dist .sles9 }
%endif

Summary: Symas' libargon2 build
Name: symas-libargon2
Version: 20190702
Release: 4%{?dist}
License: BSD
Source: %{name}-v%{version}.tar.xz

URL: https://github.com/P-H-C/phc-winner-argon2
VCS: https://git.symas.net/symas-public/libargon2.git

# Apparently distro setup should fill this in, but can't see where,
# Fake ours from dist and strip the leading dot
Distribution: %(echo %{?dist} | tr -d .)

AutoReqProv: no
# BuildRequires one at a time, microdnf doesn't support comma separated dependencies
BuildRequires: symas-buildtools >= 1.0.4
BuildRequires: gcc
BuildRequires: make

%description
The Symas libargon2 build

%package libs
Summary: libargon2 Libaries
AutoReqProv: no

%description libs
The symas-libargon2-libs package contains the libargon2 libraries

%package devel
Summary: libargon2 Development
Requires: symas-libargon2-libs = %{version}-%{release}
AutoReqProv: no

%description devel
The symas-libargon2-devel package contains the linking libraries and include files

%prep
%setup -qn %{name}-v%{version}

%if 0%{?suse_version}
sed -e 's:-O3 -Wall:%{optflags}:' \
    -e 's:-march=\$(OPTTARGET) :${CFLAGS} :' \
    -e 's:CFLAGS += -march=\$(OPTTARGET)::' \
    -i Makefile
%else
%if 0%{?centos_ver} && 0%{?centos_ver} == 7
sed -e '/^CFLAGS/s:^CFLAGS:LDFLAGS=%{__global_ldflags}\nCFLAGS:' \
    -e 's:-O3 -Wall:%{optflags}:' \
    -e 's:-march=\$(OPTTARGET) :${CFLAGS} :' \
    -e 's:CFLAGS += -march=\$(OPTTARGET)::' \
    -i Makefile
%else
sed -e '/^CFLAGS/s:^CFLAGS:LDFLAGS=%{build_ldflags}\nCFLAGS:' \
    -e 's:-O3 -Wall:%{optflags}:' \
    -e 's:-march=\$(OPTTARGET) :${CFLAGS} :' \
    -e 's:CFLAGS += -march=\$(OPTTARGET)::' \
    -i Makefile
%endif
%endif

%build
make PREFIX=%{_syprefix} LIBRARY_REL=lib

%check
make -j1 test

%install
make install DESTDIR=%{buildroot} PREFIX=%{_syprefix} LIBRARY_REL=lib
rm -f %{buildroot}%{_sylibdir}/libargon2.a
rm -rf %{buildroot}%{_syprefix}/bin
mkdir -p %{buildroot}%{_syprefix}/share/doc/libargon2/
install -m 0644 CHANGELOG.md %{buildroot}%{_syprefix}/share/doc/libargon2/
install -m 0644 LICENSE %{buildroot}%{_syprefix}/share/doc/libargon2/
install -m 0644 README.md %{buildroot}%{_syprefix}/share/doc/libargon2/

%files libs
%defattr(-,root,root)
%{_sylibdir}/*.so.*
%{_syprefix}/share/doc/libargon2

%files devel
%defattr(-,root,root)
%{_syprefix}/include
%{_sylibdir}/pkgconfig/*.pc
%{_sylibdir}/*.so

%changelog
* Tue Jun 04 2024 Symas Support <support@symas.com> - 20190702-4
- Switch to apkg for packaging
* Mon Mar 20 2023 Symas Support <support@symas.com> - 20190702-3
- VCS Tags
* Tue Nov 16 2021 Symas Support <support@symas.com> - 20190702-2
- Package LICENSE, README.md and CHANGELOG.md
* Tue Apr 6 2021 Symas Support <support@symas.com> - 20190702-1
- initial packaging
